#ifndef WATCH_STATE_H
#define WATCH_STATE_H

#include <boost/shared_ptr.hpp>

#include <string>

class watch_access;

class watch_state
{
public:

   virtual ~watch_state() = 0;

   virtual void start(watch_access& watch);

   virtual void stop(watch_access& watch);
  
private:
   // A template method used for diagnostic purpose.
   virtual std::string state_name() const = 0;
};

typedef boost::shared_ptr<watch_state> watch_state_ptr;

#endif
